#ifndef CC_H
#define CC_H

#include "graph.h"
#include <vector>


using namespace std;

class SamplingCC
{

public:

    SamplingCC(Graph * _graph, int _nSamples);
    ~SamplingCC();

    void init();
    bool iterate(set<VertexID> &candidates);
    void labelNode(VertexID vertexID);
    void lookupNextCandidates(set<VertexID> &candidates, set<VertexID> &newCandidates);
    void initSample(int sampleId);
    set<VertexID> lookupInitialCandidates();
    void saveLabels(int sampleId);
    void eval(unsigned long  tMax);
    void eval();
    int assignTopLabel(int i);
    void saveTopLabels();


    int sampleCount;
    int iterationCount;

     long *labelIds; // labelIds[nodeId][labelId] = frequency (unsigned long)


    Graph *graph;
    int nSamples; // number of samples to generate


   //double *labelsHistogram;

};

#endif // CC_H
